> ## Documentation Index
> Fetch the complete documentation index at: https://www.cockroachlabs.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Add a connection to a cluster's private endpoint service.

> Can be used by the following roles assigned at the organization, folder or cluster scope:
- CLUSTER_ADMIN
- CLUSTER_OPERATOR_WRITER


<Note>This endpoint is in **Preview** and subject to change. Refer to the [API support policy](https://www.cockroachlabs.com/docs/stable/api-support-policy) for more details.</Note>


## OpenAPI

````yaml /openapi/cloud/2023-04-10.json post /api/v1/clusters/{cluster_id}/networking/private-endpoint-connections
openapi: 3.0.0
info:
  contact:
    email: support@cockroachlabs.com
    name: Cockroach Labs Support
    url: https://support.cockroachlabs.com
  description: An API for managing CockroachDB Cloud resources
  title: CockroachDB Cloud API
  version: '2023-04-10'
servers:
  - url: https://cockroachlabs.cloud
security:
  - Bearer: []
tags:
  - name: SCIM
  - name: Organizations
  - name: Clusters
  - name: SQL Users
  - name: SQL Privilege Grants
  - name: Databases
  - name: Customer-managed Encryption Keys
  - name: Client CA Certificates
  - name: Cluster SSO
  - name: Log Export
  - name: Metric Export
  - name: Audit Logs
  - name: IP Allowlists
  - name: Egress Rules
  - name: Billing
  - name: Maintenance Windows
  - name: Role Management
  - name: Service Accounts
  - name: API Keys
  - name: Folders
  - name: Version Deferral
  - name: JWT Issuers
  - name: OpenID Connect Configuration
  - name: Private Endpoint Services
  - name: PCI
  - name: Physical Cluster Replication
  - name: Backup/Restore
externalDocs:
  description: Use the CockroachDB Cloud API
  url: https://www.cockroachlabs.com/docs/cockroachcloud/cloud-api
paths:
  /api/v1/clusters/{cluster_id}/networking/private-endpoint-connections:
    post:
      tags:
        - Private Endpoint Services
      summary: Add a connection to a cluster's private endpoint service.
      description: >
        Can be used by the following roles assigned at the organization, folder
        or cluster scope:

        - CLUSTER_ADMIN

        - CLUSTER_OPERATOR_WRITER
      operationId: CockroachCloud_AddPrivateEndpointConnection
      parameters:
        - name: cluster_id
          in: path
          description: |-
            cluster_id is the id of the cluster to which the private endpoint
            connection will be added.
          required: true
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                endpoint_id:
                  description: >-
                    endpoint_id is the id of the private endpoint associated
                    with a cluster's

                    private endpoint service. The private endpoint is
                    customer-created and

                    its id is generated by the cloud provider at endpoint
                    creation time.
                  type: string
              example:
                cluster_id: 35c4abb2-bb66-46d7-afed-25ebef5ed2aa
                endpoint_id: e-65de2gf3
              required:
                - endpoint_id
              title: AddPrivateEndpointConnectionRequest
      responses:
        '200':
          description: A successful response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PrivateEndpointConnection'
        '400':
          description: Returned when a request field is invalid.
          content:
            application/json:
              schema: {}
        '401':
          description: Returned when the token bearer cannot be authenticated.
          content:
            application/json:
              schema: {}
        '403':
          description: >-
            Returned when the user does not have permission to access the
            resource.
          content:
            application/json:
              schema: {}
        '404':
          description: Returned when the resource does not exist.
          content:
            application/json:
              schema: {}
        '500':
          description: Server error
          content:
            application/json:
              schema: {}
        default:
          description: An unexpected error response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Status'
      x-codeSamples:
        - lang: curl
          source: |-
            curl --request POST \
              --url https://cockroachlabs.cloud/api/v1/clusters/{cluster_id}/networking/private-endpoint-connections \
              --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
              --json '{"cluster_id":"35c4abb2-bb66-46d7-afed-25ebef5ed2aa","endpoint_id":"e-65de2gf3"}'
components:
  schemas:
    PrivateEndpointConnection:
      type: object
      properties:
        cloud_provider:
          $ref: '#/components/schemas/CloudProvider.Type'
        endpoint_id:
          description: |-
            endpoint_id is the id of the private endpoint associated with this
            connection. The private endpoint is customer-created and its id is
            generated by the cloud provider at endpoint creation time.
          type: string
        endpoint_service_id:
          description: >-
            endpoint_service_id is the id of the private endpoint service
            associated

            with this connection.
          type: string
        external_owner_id:
          description: >-
            external_owner_id uniquely identifies the owner of the private
            endpoint

            connection cloud resource. This idenfier is the AWS account id

            owning the PrivateLink connection. This field is only valid on AWS
            clusters.
          type: string
        region_name:
          description: region_name is the cloud provider region name (e.g. us-east-1).
          type: string
        service_name:
          description: >-
            service_name is the name of the private endpoints service that this
            connection

            corresponds to.
          type: string
        status:
          $ref: '#/components/schemas/PrivateEndpointConnectionStatus'
      example:
        cloud: AWS
        cloud_provider: AWS
        endpoint_id: 2w543-45643-323fd
        endpoint_service_id: 34t-4t446-876bm
        region: us-east-1
        service_name: com.vpc-serv1
        status: STATUS_AVAILABLE
      required:
        - region
        - cloud_provider
        - status
        - endpoint_id
        - endpoint_service_id
        - service_name
    Status:
      type: object
      properties:
        code:
          type: integer
          format: int32
        details:
          type: array
          items:
            $ref: '#/components/schemas/Any'
        message:
          type: string
    CloudProvider.Type:
      description: |2-
         - GCP: The Google Cloud Platform cloud provider.
         - AWS: The Amazon Web Services cloud provider.
         - AZURE: The Azure cloud provider.
      type: string
      enum:
        - GCP
        - AWS
        - AZURE
    PrivateEndpointConnectionStatus:
      description: |-
        PrivateEndpointConnectionStatus enumerates the possible statuses
        for the private endpoints connection.
      type: string
      enum:
        - STATUS_PENDING
        - STATUS_PENDING_ACCEPTANCE
        - STATUS_AVAILABLE
        - STATUS_DELETING
        - STATUS_DELETED
        - STATUS_REJECTED
        - STATUS_FAILED
        - STATUS_EXPIRED
    Any:
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message.


        Protobuf library provides support to pack/unpack Any values in the form

        of utility functions or additional generated methods of the Any type.


        Example 1: Pack and unpack a message in C++.

            Foo foo = ...;
            Any any;
            any.PackFrom(foo);
            ...
            if (any.UnpackTo(&foo)) {
              ...
            }

        Example 2: Pack and unpack a message in Java.

            Foo foo = ...;
            Any any = Any.pack(foo);
            ...
            if (any.is(Foo.class)) {
              foo = any.unpack(Foo.class);
            }
            // or ...
            if (any.isSameTypeAs(Foo.getDefaultInstance())) {
              foo = any.unpack(Foo.getDefaultInstance());
            }

         Example 3: Pack and unpack a message in Python.

            foo = Foo(...)
            any = Any()
            any.Pack(foo)
            ...
            if any.Is(Foo.DESCRIPTOR):
              any.Unpack(foo)
              ...

         Example 4: Pack and unpack a message in Go

             foo := &pb.Foo{...}
             any, err := anypb.New(foo)
             if err != nil {
               ...
             }
             ...
             foo := &pb.Foo{}
             if err := any.UnmarshalTo(foo); err != nil {
               ...
             }

        The pack methods provided by protobuf library will by default use

        'type.googleapis.com/full.type.name' as the type URL and the unpack

        methods only use the fully qualified type name after the last '/'

        in the type URL, for example "foo.bar.com/x/y.z" will yield type

        name "y.z".


        JSON

        ====

        The JSON representation of an `Any` value uses the regular

        representation of the deserialized, embedded message, with an

        additional field `@type` which contains the type URL. Example:

            package google.profile;
            message Person {
              string first_name = 1;
              string last_name = 2;
            }

            {
              "@type": "type.googleapis.com/google.profile.Person",
              "firstName": <string>,
              "lastName": <string>
            }

        If the embedded message type is well-known and has a custom JSON

        representation, that representation will be embedded adding a field

        `value` which holds the custom JSON in addition to the `@type`

        field. Example (for message [google.protobuf.Duration][]):

            {
              "@type": "type.googleapis.com/google.protobuf.Duration",
              "value": "1.212s"
            }
      type: object
      properties:
        '@type':
          description: >-
            A URL/resource name that uniquely identifies the type of the
            serialized

            protocol buffer message. This string must contain at least

            one "/" character. The last segment of the URL's path must represent

            the fully qualified name of the type (as in

            `path/google.protobuf.Duration`). The name should be in a canonical
            form

            (e.g., leading "." is not accepted).


            In practice, teams usually precompile into the binary all types that
            they

            expect it to use in the context of Any. However, for URLs which use
            the

            scheme `http`, `https`, or no scheme, one can optionally set up a
            type

            server that maps type URLs to message definitions as follows:


            * If no scheme is provided, `https` is assumed.

            * An HTTP GET on the URL must yield a [google.protobuf.Type][]
              value in binary format, or produce an error.
            * Applications are allowed to cache lookup results based on the
              URL, or have them precompiled into a binary to avoid any
              lookup. Therefore, binary compatibility needs to be preserved
              on changes to types. (Use versioned type names to manage
              breaking changes.)

            Note: this functionality is not currently available in the official

            protobuf release, and it is not used for type URLs beginning with

            type.googleapis.com. As of May 2023, there are no widely used type
            server

            implementations and no plans to implement one.


            Schemes other than `http`, `https` (or the empty scheme) might be

            used with implementation specific semantics.
          type: string
      additionalProperties: {}
  securitySchemes:
    Bearer:
      type: http
      scheme: bearer

````